<template>
    <div v-if="!closeAlert">
        <div :class="['ui-alert-container', type]">
            <div class="ui-alert-header">
                <div class="ui-alert-header-title">
                    <UiIcon :fill="iconColor">{{`${type}-icon`}}</UiIcon>
                    <div class="ui-alert-header-text">{{ this.alertTitle }}</div>
                </div>

                <div class="expandedIcon" @click="closeAlert = true" v-if="isSingleLine">
                    <UiIcon :fill="iconColor" viewBox="0 0 45 45">close-45</UiIcon>
                </div>
                <div
                    @click="switchAlertContent"
                    :class="['expandedIcon', { expanded: contentEnable }]"
                    v-else
                >
                    <UiIcon :fill="iconColor" viewBox="0 0 20 20">collapse-20</UiIcon>
                </div>
            </div>

            <div v-show="contentEnable" :class="['ui-alert-body', { expanded: contentEnable }]">
                <slot name="alert-body"></slot>
            </div>
        </div>
    </div>
</template>

<script>

export default {
    name: 'ui-component-alert',

    props: {
        isExpanded: {
            type: Boolean,
            default: false
        },
        isSingleLine: {
            type: Boolean,
            default: true
        },
        alertTitle: String,
        type: {
            type: String,
            default: 'info',
            validator: val => ['success', 'warning', 'info', 'error'].find(state => state === val)
        }
    },

    data: () => ({
        contentEnable: true,
        closeAlert: false
    }),

    computed: {
        iconColor () {
            return this.$ui.colors[this.type]
        }
    },

    methods: {
        switchAlertContent() {
            this.contentEnable = !this.contentEnable
        }
    }
}
</script>
